﻿Enumeration
  ;labels
  #l0
  #l1
  #l2
  #l3
  #l4
  #l5
  #l6
  #l7
  #l8
  #l9
  #l10
  #l11
  #l12
  #l13
  #l14
  #l15
  #l16
  #l17
  #l18
  #l19
  #l20
  #l21
  #l22
  #l23
  #l24
  #l25
  #l26
  #l27
  #l28
  #l29
  #l30
  #l31
  #l32
  ;text fields
  #t0
  #t1
  #t2
  #t3
  #t4
  #t5
  #t6
  #t7
  #t8
  #t9
  #t10
  #t11
  #t12
  #t13
  #t14
  #t15
  #t16
  #t17
  #t18
  #t19
  #t20
  #t21
  #t22
  #t23
  #t24
  #t25
  #t26
  #t27
  #t28
  #t29
  #t30
  #t31
  #t32
  ;rest
  #s1
  #s2
  #underscore
EndEnumeration

Enumeration ; menu
  #file_delete
  #file_clear
  #file_rename
  #file_quit
EndEnumeration

;-begin program
Global Dim tt.s(32)

;Global  hicon=LoadIcon_(GetModuleHandle_(0),101)
Global Dim ico(2)

Procedure sortt()
  For i=0 To 31
    For k=i+1 To 32
      If Len(tt(i))<Len(tt(k))
        t.s=tt(k)
        tt(k)=tt(i)
        tt(i)=t
      EndIf
    Next k
  Next i
EndProcedure

Procedure showt()
  For i=0 To 32
    Debug tt(i)
  Next i
EndProcedure

Procedure preview()
  nn=CountGadgetItems(#s1)
  ClearGadgetItems(#s2)
  If nn
    For i=0 To nn
      f$=GetGadgetItemText(#s1,i)
      p$=GetFilePart(f$,#PB_FileSystem_NoExtension)
      
      ;Debug p$
      For k=0 To 32 ; do translit
        la$=tt(k)
        ;Debug la$
        ru$=Mid(la$,1,1)
        la$=Mid(la$,2)
        If Len(la$)>1
          la1$=UCase(Mid(la$,1,1))+LCase(Mid(la$,2))
          p$=ReplaceString(p$,la1$,ru$,#PB_String_CaseSensitive)
          p$=ReplaceString(p$,la$,ru$,#PB_String_CaseSensitive)
        EndIf
        p$=ReplaceString(p$,UCase(la$),ru$,#PB_String_CaseSensitive)
        p$=ReplaceString(p$,LCase(la$),LCase(ru$),#PB_String_CaseSensitive)
      Next k
      If GetGadgetState(#underscore)
        p$=ReplaceString(p$,"_"," ")
      EndIf
      AddGadgetItem(#s2,i,GetPathPart(f$)+p$+"."+GetExtensionPart(f$))
    Next i
  EndIf
EndProcedure
;----------------------------------------------------------------------------------------------------------
;ownerdraw routine
Procedure.l callback(hWnd, msg, wParam, lParam) 
  Protected hlistview, hbrush, hbrushold, rct.RECT, *lpdis.DRAWITEMSTRUCT, text.s
  result = #PB_ProcessPureBasicEvents
  If msg=#WM_DRAWITEM
    
          hlistview = GetDlgItem_(WindowID(0),wParam) ;Handle of the listview. This avoids hard coding for a single listview gadget.
      *lpdis = lParam
      If *lpdis\itemID <> -1
 
 ;Here we trap only the #ODA_DRAWENTIRE and #ODA_SELECT stages. A more sophisticated program would
 ;undoubtedly consider #ODA_FOCUS also.
        If *lpdis\itemAction = #ODA_DRAWENTIRE Or *lpdis\itemAction = #ODA_SELECT; Or *lpdis\itemAction = #ODA_FOCUS
          text=Space(255)

;Clear background. Here we alternate background colour.*****
           If *lpdis\itemID & 1 = 1
             rgbc=RGB($ee,$ee,$ee);hbrush = CreateSolidBrush_(RGB($ee,$ee,$ee))
           Else
             rgbc=RGB($cc,$cc,$cc);hbrush = CreateSolidBrush_(RGB($cc,$cc,$cc))
           EndIf
           
           textc=0
           If *lpdis\itemState & #ODS_SELECTED
             rgbc=GetSysColor_(#COLOR_HIGHLIGHT)
             textc=$FFFFFF
           EndIf
           
          hbrush = CreateSolidBrush_(rgbc)
           
          hbrushold = SelectObject_(*lpdis\hdc,hbrush)
          FillRect_(*lpdis\hdc, *lpdis\rcItem, hbrush)
          SelectObject_(*lpdis\hdc,hbrushold)
          ;DeleteObject_(hbrush)
;Draw text. Here we alternate the text colour.**************
          SetBkMode_(*lpdis\hdc,#TRANSPARENT)
;           If *lpdis\itemID & 1 = 1
;             SetTextColor_(*lpdis\hdc, RGB($ff,0,0));COLOR_HIGHLIGHTTEXT
;           Else
;             SetTextColor_(*lpdis\hdc, RGB(0,0,$ff))
;           EndIf
          SetTextColor_(*lpdis\hdc, textc)
          SendMessage_(hlistview, #LB_GETTEXT, *lpdis\itemID, @text)
          TextOut_(*lpdis\hdc,*lpdis\rcItem\left+2+16, *lpdis\rcItem\top + 2, @text, Len(text))
          ;Debug text+","+Str(GetGadgetState(#s1))+","+Str(*lpdis\itemID)

          hbrush = CreateSolidBrush_(rgbc)
          SelectObject_(*lpdis\hdc,hbrush)
          DrawIconEx_(*lpdis\hdc,*lpdis\rcItem\left,*lpdis\rcItem\top,ico(*lpdis\itemData),16,16,0,hbrush,#DI_IMAGE)
          DeleteObject_(hbrush)
;***********************************************************
          result = #True
        ElseIf *lpdis\itemAction = #ODA_FOCUS
          result = #True
        EndIf
      EndIf  
    
EndIf
  ProcedureReturn result
EndProcedure
;----------------------------------------------------------------------------------------------------------

If OpenWindow(0, 0, 0, 640, 480, "file translit 0.9", #PB_Window_SystemMenu | #PB_Window_ScreenCentered|#PB_Window_MinimizeGadget)
  ;build gadgets
  Restore trules
  For n=0 To 2
    For k=0 To 10
      Read.s t.s
      tt(k+n*11)=t
      ;Debug t
      TextGadget(#l0+k+n*11,k*55,n*20+2,15,20,Mid(t,1,1),#PB_Text_Center)
      StringGadget(#t0+k+n*11,15+k*55,n*20,30,20,Mid(t,2),#ES_CENTER)
    Next k
  Next n 
  
  sortt()
  
  ;load icons
  ;0 - green check
  ;1 - paper
  ;2 - disable
  
  For i=0 To 2
    ico(i)=LoadIcon_(GetModuleHandle_(0),100+i)
  Next i
  
  ListViewGadget(#s1,0,70,640,180,#LBS_OWNERDRAWFIXED)
  GadgetToolTip(#s1,"Drop files")
  ListViewGadget(#s2,0,250,640,180)
  GadgetToolTip(#s2,"Preview")
  CheckBoxGadget(#underscore,0,440,640,20,"replace '_'")
  GadgetToolTip(#underscore,"replace '_' to space")
  EnableGadgetDrop(#s1, #PB_Drop_Files,#PB_Drag_Copy)
  ;menu
   If CreateMenu(0, WindowID(0))
      MenuTitle("File")
        MenuItem(#file_delete, "Delete item"+Chr(9)+"Del")
        MenuItem(#file_clear, "Clear list")
        MenuItem(#file_rename, "Rename"+Chr(9)+"F2")
        MenuBar()
        MenuItem(#file_quit, "Quit")
        
        AddKeyboardShortcut(0,#PB_Shortcut_F2,#file_rename)
        AddKeyboardShortcut(0,#PB_Shortcut_Delete,#file_delete)
    EndIf

  
;     AddGadgetItem(#s1,0,"d:\fileren\Yuriy_Kasparyan_i_Prezidentskiy_orkestr_Respubliki_Belarus_Peremen.mp3")
;     SetGadgetItemData(#s1,0,1);1-OK
;   AddGadgetItem(#s1,1,"pizdec");2-error
;   SetGadgetItemData(#s1,1,1)
  preview()
  
  SetWindowCallback(@callback())
  
  Repeat
    ev=WaitWindowEvent()
    If GetAsyncKeyState_(#VK_ESCAPE)&32768
      Break
    EndIf
    
    Select ev
       Case #PB_Event_Menu
         Select EventMenu()
           Case #file_rename
             nn=CountGadgetItems(#s1)
             If nn
               For i=0 To nn-1
                 s1$=GetGadgetItemText(#s1,i)
                 s2$=GetGadgetItemText(#s2,i)
                 If RenameFile(s1$,s2$)
                   SetGadgetItemData(#s1,i,0)
                 Else
                   SetGadgetItemData(#s1,i,2)
                 EndIf
                 SetGadgetState(#s1,i)
               Next i
               ;SetGadgetState(#s1,-1)
               ;SendMessage_(GadgetID(#s1))
               SetActiveGadget(#s1)
             EndIf
           Case #file_delete
             it=GetGadgetState(#s1)
             If it<>-1
               RemoveGadgetItem(#s1,it)
               preview()
             EndIf
           Case #file_clear
             ClearGadgetItems(#s1)
             ClearGadgetItems(#s2)
           Case #file_quit
             Break
         EndSelect

      Case #PB_Event_GadgetDrop
        SetGadgetState(#s1, -1)
        f$=EventDropFiles()
        Count  = CountString(f$, Chr(10)) + 1
        For i = 1 To Count
          AddGadgetItem( #s1,CountGadgetItems(#s1), StringField(f$, i, Chr(10)) )
          SetGadgetItemData(#s1, CountGadgetItems(#s1)-1, 1)
        Next i
        preview()
      Case #PB_Event_Gadget
        eg=EventGadget()
        Select eg
          Case #underscore
            preview()
          Case #t0 To #t32
            If EventType()=#PB_EventType_Change
              l1.s=GetGadgetText(eg)
              l2.s=GetGadgetText(eg-#t0+#l0)
              ;Debug l2+":"+l1
              For i=0 To 32
                If Mid(tt(i),1,1)=l2
                  tt(i)=l2+l1
                  sortt()
                  Break
                EndIf
              Next i
              preview()
            EndIf
        EndSelect
    EndSelect
  Until ev = #PB_Event_CloseWindow
EndIf

DataSection
  trules:
  Data.s "АA"
  Data.s "БB"
  Data.s "ВV"
  Data.s "ГG"
  Data.s "ДD"
  Data.s "ЕE"
  Data.s "ЁYO"
  Data.s "ЖZH"
  Data.s "ЗZ"
  Data.s "ИI"
  Data.s "ЙJ"
  Data.s "КK"
  Data.s "ЛL"
  Data.s "МM"
  Data.s "НN"
  Data.s "ОO"
  Data.s "ПP"
  Data.s "РR"
  Data.s "СS"
  Data.s "ТT"
  Data.s "УU"
  Data.s "ФF"
  Data.s "ХKH"
  Data.s "ЦTS"
  Data.s "ЧCH"
  Data.s "ШSH"
  Data.s "ЩSCH";SHCH
  Data.s "Ъ"
  Data.s "ЫY"
  Data.s "Ь"
  Data.s "ЭE"
  Data.s "ЮYU"
  Data.s "ЯYA"
  
  imgch:
  IncludeBinary "check16.ico"
  imgdis:
  IncludeBinary "disable05.ico"
  imgfile:
  IncludeBinary "paper33.ico"
; IDE Options = PureBasic 5.30 (Windows - x86)
; CursorPosition = 198
; FirstLine = 187
; Folding = -
; EnableUnicode
; EnableXP
; UseIcon = trans.ico
; Executable = filetran.exe
; AddResource = trans.rc